/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataGoogleFilestoreInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/data-sources/google_filestore_instance#id DataGoogleFilestoreInstance#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The name of the location of the instance. This can be a region for ENTERPRISE tier instances.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/data-sources/google_filestore_instance#location DataGoogleFilestoreInstance#location}
    */
    readonly location?: string;
    /**
    * The resource name of the instance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/data-sources/google_filestore_instance#name DataGoogleFilestoreInstance#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/data-sources/google_filestore_instance#project DataGoogleFilestoreInstance#project}
    */
    readonly project?: string;
}
export interface DataGoogleFilestoreInstanceFileSharesNfsExportOptions {
}
export declare function dataGoogleFilestoreInstanceFileSharesNfsExportOptionsToTerraform(struct?: DataGoogleFilestoreInstanceFileSharesNfsExportOptions): any;
export declare function dataGoogleFilestoreInstanceFileSharesNfsExportOptionsToHclTerraform(struct?: DataGoogleFilestoreInstanceFileSharesNfsExportOptions): any;
export declare class DataGoogleFilestoreInstanceFileSharesNfsExportOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataGoogleFilestoreInstanceFileSharesNfsExportOptions | undefined;
    set internalValue(value: DataGoogleFilestoreInstanceFileSharesNfsExportOptions | undefined);
    get accessMode(): string;
    get anonGid(): number;
    get anonUid(): number;
    get ipRanges(): string[];
    get squashMode(): string;
}
export declare class DataGoogleFilestoreInstanceFileSharesNfsExportOptionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataGoogleFilestoreInstanceFileSharesNfsExportOptionsOutputReference;
}
export interface DataGoogleFilestoreInstanceFileShares {
}
export declare function dataGoogleFilestoreInstanceFileSharesToTerraform(struct?: DataGoogleFilestoreInstanceFileShares): any;
export declare function dataGoogleFilestoreInstanceFileSharesToHclTerraform(struct?: DataGoogleFilestoreInstanceFileShares): any;
export declare class DataGoogleFilestoreInstanceFileSharesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataGoogleFilestoreInstanceFileShares | undefined;
    set internalValue(value: DataGoogleFilestoreInstanceFileShares | undefined);
    get capacityGb(): number;
    get name(): string;
    private _nfsExportOptions;
    get nfsExportOptions(): DataGoogleFilestoreInstanceFileSharesNfsExportOptionsList;
    get sourceBackup(): string;
}
export declare class DataGoogleFilestoreInstanceFileSharesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataGoogleFilestoreInstanceFileSharesOutputReference;
}
export interface DataGoogleFilestoreInstanceNetworks {
}
export declare function dataGoogleFilestoreInstanceNetworksToTerraform(struct?: DataGoogleFilestoreInstanceNetworks): any;
export declare function dataGoogleFilestoreInstanceNetworksToHclTerraform(struct?: DataGoogleFilestoreInstanceNetworks): any;
export declare class DataGoogleFilestoreInstanceNetworksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataGoogleFilestoreInstanceNetworks | undefined;
    set internalValue(value: DataGoogleFilestoreInstanceNetworks | undefined);
    get connectMode(): string;
    get ipAddresses(): string[];
    get modes(): string[];
    get network(): string;
    get reservedIpRange(): string;
}
export declare class DataGoogleFilestoreInstanceNetworksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataGoogleFilestoreInstanceNetworksOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/data-sources/google_filestore_instance google_filestore_instance}
*/
export declare class DataGoogleFilestoreInstance extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "google_filestore_instance";
    /**
    * Generates CDKTF code for importing a DataGoogleFilestoreInstance resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataGoogleFilestoreInstance to import
    * @param importFromId The id of the existing DataGoogleFilestoreInstance that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/data-sources/google_filestore_instance#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataGoogleFilestoreInstance to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/data-sources/google_filestore_instance google_filestore_instance} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataGoogleFilestoreInstanceConfig
    */
    constructor(scope: Construct, id: string, config: DataGoogleFilestoreInstanceConfig);
    get createTime(): string;
    get deletionProtectionEnabled(): cdktf.IResolvable;
    get deletionProtectionReason(): string;
    get description(): string;
    private _effectiveLabels;
    get effectiveLabels(): cdktf.StringMap;
    get etag(): string;
    private _fileShares;
    get fileShares(): DataGoogleFilestoreInstanceFileSharesList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get kmsKeyName(): string;
    private _labels;
    get labels(): cdktf.StringMap;
    private _location?;
    get location(): string;
    set location(value: string);
    resetLocation(): void;
    get locationInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _networks;
    get networks(): DataGoogleFilestoreInstanceNetworksList;
    private _project?;
    get project(): string;
    set project(value: string);
    resetProject(): void;
    get projectInput(): string | undefined;
    get protocol(): string;
    private _terraformLabels;
    get terraformLabels(): cdktf.StringMap;
    get tier(): string;
    get zone(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
