/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface GoogleClouddeployCustomTargetTypeIamMemberConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_clouddeploy_custom_target_type_iam_member#id GoogleClouddeployCustomTargetTypeIamMember#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_clouddeploy_custom_target_type_iam_member#location GoogleClouddeployCustomTargetTypeIamMember#location}
    */
    readonly location?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_clouddeploy_custom_target_type_iam_member#member GoogleClouddeployCustomTargetTypeIamMember#member}
    */
    readonly member: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_clouddeploy_custom_target_type_iam_member#name GoogleClouddeployCustomTargetTypeIamMember#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_clouddeploy_custom_target_type_iam_member#project GoogleClouddeployCustomTargetTypeIamMember#project}
    */
    readonly project?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_clouddeploy_custom_target_type_iam_member#role GoogleClouddeployCustomTargetTypeIamMember#role}
    */
    readonly role: string;
    /**
    * condition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_clouddeploy_custom_target_type_iam_member#condition GoogleClouddeployCustomTargetTypeIamMember#condition}
    */
    readonly condition?: GoogleClouddeployCustomTargetTypeIamMemberCondition;
}
export interface GoogleClouddeployCustomTargetTypeIamMemberCondition {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_clouddeploy_custom_target_type_iam_member#description GoogleClouddeployCustomTargetTypeIamMember#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_clouddeploy_custom_target_type_iam_member#expression GoogleClouddeployCustomTargetTypeIamMember#expression}
    */
    readonly expression: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_clouddeploy_custom_target_type_iam_member#title GoogleClouddeployCustomTargetTypeIamMember#title}
    */
    readonly title: string;
}
export declare function googleClouddeployCustomTargetTypeIamMemberConditionToTerraform(struct?: GoogleClouddeployCustomTargetTypeIamMemberConditionOutputReference | GoogleClouddeployCustomTargetTypeIamMemberCondition): any;
export declare function googleClouddeployCustomTargetTypeIamMemberConditionToHclTerraform(struct?: GoogleClouddeployCustomTargetTypeIamMemberConditionOutputReference | GoogleClouddeployCustomTargetTypeIamMemberCondition): any;
export declare class GoogleClouddeployCustomTargetTypeIamMemberConditionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): GoogleClouddeployCustomTargetTypeIamMemberCondition | undefined;
    set internalValue(value: GoogleClouddeployCustomTargetTypeIamMemberCondition | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _expression?;
    get expression(): string;
    set expression(value: string);
    get expressionInput(): string | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_clouddeploy_custom_target_type_iam_member google_clouddeploy_custom_target_type_iam_member}
*/
export declare class GoogleClouddeployCustomTargetTypeIamMember extends cdktf.TerraformResource {
    static readonly tfResourceType = "google_clouddeploy_custom_target_type_iam_member";
    /**
    * Generates CDKTF code for importing a GoogleClouddeployCustomTargetTypeIamMember resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the GoogleClouddeployCustomTargetTypeIamMember to import
    * @param importFromId The id of the existing GoogleClouddeployCustomTargetTypeIamMember that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_clouddeploy_custom_target_type_iam_member#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the GoogleClouddeployCustomTargetTypeIamMember to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_clouddeploy_custom_target_type_iam_member google_clouddeploy_custom_target_type_iam_member} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options GoogleClouddeployCustomTargetTypeIamMemberConfig
    */
    constructor(scope: Construct, id: string, config: GoogleClouddeployCustomTargetTypeIamMemberConfig);
    get etag(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _location?;
    get location(): string;
    set location(value: string);
    resetLocation(): void;
    get locationInput(): string | undefined;
    private _member?;
    get member(): string;
    set member(value: string);
    get memberInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _project?;
    get project(): string;
    set project(value: string);
    resetProject(): void;
    get projectInput(): string | undefined;
    private _role?;
    get role(): string;
    set role(value: string);
    get roleInput(): string | undefined;
    private _condition;
    get condition(): GoogleClouddeployCustomTargetTypeIamMemberConditionOutputReference;
    putCondition(value: GoogleClouddeployCustomTargetTypeIamMemberCondition): void;
    resetCondition(): void;
    get conditionInput(): GoogleClouddeployCustomTargetTypeIamMemberCondition | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
