/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface GoogleIapTunnelDestGroupIamMemberConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_iap_tunnel_dest_group_iam_member#dest_group GoogleIapTunnelDestGroupIamMember#dest_group}
    */
    readonly destGroup: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_iap_tunnel_dest_group_iam_member#id GoogleIapTunnelDestGroupIamMember#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_iap_tunnel_dest_group_iam_member#member GoogleIapTunnelDestGroupIamMember#member}
    */
    readonly member: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_iap_tunnel_dest_group_iam_member#project GoogleIapTunnelDestGroupIamMember#project}
    */
    readonly project?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_iap_tunnel_dest_group_iam_member#region GoogleIapTunnelDestGroupIamMember#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_iap_tunnel_dest_group_iam_member#role GoogleIapTunnelDestGroupIamMember#role}
    */
    readonly role: string;
    /**
    * condition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_iap_tunnel_dest_group_iam_member#condition GoogleIapTunnelDestGroupIamMember#condition}
    */
    readonly condition?: GoogleIapTunnelDestGroupIamMemberCondition;
}
export interface GoogleIapTunnelDestGroupIamMemberCondition {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_iap_tunnel_dest_group_iam_member#description GoogleIapTunnelDestGroupIamMember#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_iap_tunnel_dest_group_iam_member#expression GoogleIapTunnelDestGroupIamMember#expression}
    */
    readonly expression: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_iap_tunnel_dest_group_iam_member#title GoogleIapTunnelDestGroupIamMember#title}
    */
    readonly title: string;
}
export declare function googleIapTunnelDestGroupIamMemberConditionToTerraform(struct?: GoogleIapTunnelDestGroupIamMemberConditionOutputReference | GoogleIapTunnelDestGroupIamMemberCondition): any;
export declare function googleIapTunnelDestGroupIamMemberConditionToHclTerraform(struct?: GoogleIapTunnelDestGroupIamMemberConditionOutputReference | GoogleIapTunnelDestGroupIamMemberCondition): any;
export declare class GoogleIapTunnelDestGroupIamMemberConditionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): GoogleIapTunnelDestGroupIamMemberCondition | undefined;
    set internalValue(value: GoogleIapTunnelDestGroupIamMemberCondition | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _expression?;
    get expression(): string;
    set expression(value: string);
    get expressionInput(): string | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_iap_tunnel_dest_group_iam_member google_iap_tunnel_dest_group_iam_member}
*/
export declare class GoogleIapTunnelDestGroupIamMember extends cdktf.TerraformResource {
    static readonly tfResourceType = "google_iap_tunnel_dest_group_iam_member";
    /**
    * Generates CDKTF code for importing a GoogleIapTunnelDestGroupIamMember resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the GoogleIapTunnelDestGroupIamMember to import
    * @param importFromId The id of the existing GoogleIapTunnelDestGroupIamMember that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_iap_tunnel_dest_group_iam_member#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the GoogleIapTunnelDestGroupIamMember to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_iap_tunnel_dest_group_iam_member google_iap_tunnel_dest_group_iam_member} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options GoogleIapTunnelDestGroupIamMemberConfig
    */
    constructor(scope: Construct, id: string, config: GoogleIapTunnelDestGroupIamMemberConfig);
    private _destGroup?;
    get destGroup(): string;
    set destGroup(value: string);
    get destGroupInput(): string | undefined;
    get etag(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _member?;
    get member(): string;
    set member(value: string);
    get memberInput(): string | undefined;
    private _project?;
    get project(): string;
    set project(value: string);
    resetProject(): void;
    get projectInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _role?;
    get role(): string;
    set role(value: string);
    get roleInput(): string | undefined;
    private _condition;
    get condition(): GoogleIapTunnelDestGroupIamMemberConditionOutputReference;
    putCondition(value: GoogleIapTunnelDestGroupIamMemberCondition): void;
    resetCondition(): void;
    get conditionInput(): GoogleIapTunnelDestGroupIamMemberCondition | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
