/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface GoogleNetworkSecurityAddressGroupIamMemberConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_network_security_address_group_iam_member#id GoogleNetworkSecurityAddressGroupIamMember#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_network_security_address_group_iam_member#location GoogleNetworkSecurityAddressGroupIamMember#location}
    */
    readonly location?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_network_security_address_group_iam_member#member GoogleNetworkSecurityAddressGroupIamMember#member}
    */
    readonly member: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_network_security_address_group_iam_member#name GoogleNetworkSecurityAddressGroupIamMember#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_network_security_address_group_iam_member#project GoogleNetworkSecurityAddressGroupIamMember#project}
    */
    readonly project?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_network_security_address_group_iam_member#role GoogleNetworkSecurityAddressGroupIamMember#role}
    */
    readonly role: string;
    /**
    * condition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_network_security_address_group_iam_member#condition GoogleNetworkSecurityAddressGroupIamMember#condition}
    */
    readonly condition?: GoogleNetworkSecurityAddressGroupIamMemberCondition;
}
export interface GoogleNetworkSecurityAddressGroupIamMemberCondition {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_network_security_address_group_iam_member#description GoogleNetworkSecurityAddressGroupIamMember#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_network_security_address_group_iam_member#expression GoogleNetworkSecurityAddressGroupIamMember#expression}
    */
    readonly expression: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_network_security_address_group_iam_member#title GoogleNetworkSecurityAddressGroupIamMember#title}
    */
    readonly title: string;
}
export declare function googleNetworkSecurityAddressGroupIamMemberConditionToTerraform(struct?: GoogleNetworkSecurityAddressGroupIamMemberConditionOutputReference | GoogleNetworkSecurityAddressGroupIamMemberCondition): any;
export declare function googleNetworkSecurityAddressGroupIamMemberConditionToHclTerraform(struct?: GoogleNetworkSecurityAddressGroupIamMemberConditionOutputReference | GoogleNetworkSecurityAddressGroupIamMemberCondition): any;
export declare class GoogleNetworkSecurityAddressGroupIamMemberConditionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): GoogleNetworkSecurityAddressGroupIamMemberCondition | undefined;
    set internalValue(value: GoogleNetworkSecurityAddressGroupIamMemberCondition | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _expression?;
    get expression(): string;
    set expression(value: string);
    get expressionInput(): string | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_network_security_address_group_iam_member google_network_security_address_group_iam_member}
*/
export declare class GoogleNetworkSecurityAddressGroupIamMember extends cdktf.TerraformResource {
    static readonly tfResourceType = "google_network_security_address_group_iam_member";
    /**
    * Generates CDKTF code for importing a GoogleNetworkSecurityAddressGroupIamMember resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the GoogleNetworkSecurityAddressGroupIamMember to import
    * @param importFromId The id of the existing GoogleNetworkSecurityAddressGroupIamMember that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_network_security_address_group_iam_member#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the GoogleNetworkSecurityAddressGroupIamMember to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.10.0/docs/resources/google_network_security_address_group_iam_member google_network_security_address_group_iam_member} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options GoogleNetworkSecurityAddressGroupIamMemberConfig
    */
    constructor(scope: Construct, id: string, config: GoogleNetworkSecurityAddressGroupIamMemberConfig);
    get etag(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _location?;
    get location(): string;
    set location(value: string);
    resetLocation(): void;
    get locationInput(): string | undefined;
    private _member?;
    get member(): string;
    set member(value: string);
    get memberInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _project?;
    get project(): string;
    set project(value: string);
    resetProject(): void;
    get projectInput(): string | undefined;
    private _role?;
    get role(): string;
    set role(value: string);
    get roleInput(): string | undefined;
    private _condition;
    get condition(): GoogleNetworkSecurityAddressGroupIamMemberConditionOutputReference;
    putCondition(value: GoogleNetworkSecurityAddressGroupIamMemberCondition): void;
    resetCondition(): void;
    get conditionInput(): GoogleNetworkSecurityAddressGroupIamMemberCondition | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
